Index: include/libroar/stream.h
===================================================================
--- include/libroar/stream.h	(revision 5219)
+++ include/libroar/stream.h	(revision 5238)
@@ -57,6 +57,5 @@
 };
 
-int roar_stream_connect  (struct roar_connection * con, struct roar_stream * s, int dir) _LIBROAR_STREAM_STDATTRS _LIBROAR_ATTR_DEPRECATED;
-int roar_stream_connect2 (struct roar_connection * con, struct roar_stream * s, int dir, int mixer) _LIBROAR_STREAM_STDATTRS;
+int roar_stream_connect (struct roar_connection * con, struct roar_stream * s, int dir, int mixer) _LIBROAR_STREAM_STDATTRS;
 
 int roar_stream_new     (struct roar_stream * s, unsigned int rate, unsigned int channels, unsigned int bits, unsigned int codec) _LIBROAR_ATTR_NONNULL_ALL;
@@ -84,8 +83,4 @@
 int roar_stream_attach_simple (struct roar_connection * con, struct roar_stream * s, int client) _LIBROAR_STREAM_STDATTRS;
 
-int roar_stream_add_data (struct roar_connection * con, struct roar_stream * s, char * data, size_t len) _LIBROAR_STREAM_STDATTRS _LIBROAR_ATTR_DEPRECATED;
-
-int roar_stream_send_data (struct roar_connection * con, struct roar_stream * s, char * data, size_t len) _LIBROAR_STREAM_STDATTRS _LIBROAR_ATTR_DEPRECATED;
-
 int roar_stream_get_info (struct roar_connection * con, struct roar_stream * s, struct roar_stream_info * info) _LIBROAR_STREAM_STDATTRS;
 int roar_stream_get_name (struct roar_connection * con, struct roar_stream * s, char * name, size_t len) _LIBROAR_STREAM_STDATTRS;
@@ -94,6 +89,5 @@
 int roar_stream_set_chanmap (struct roar_connection * con, struct roar_stream * s, char * map, size_t   len) _LIBROAR_STREAM_STDATTRS;
 
-int roar_stream_set_flags  (struct roar_connection * con, struct roar_stream * s, int flags, int reset) _LIBROAR_STREAM_STDATTRS _LIBROAR_ATTR_DEPRECATED;
-int roar_stream_set_flags2 (struct roar_connection * con, struct roar_stream * s, uint32_t flags, int action) _LIBROAR_STREAM_STDATTRS;
+int roar_stream_set_flags  (struct roar_connection * con, struct roar_stream * s, uint32_t flags, int action) _LIBROAR_STREAM_STDATTRS;
 
 int roar_stream_set_role  (struct roar_connection * con, struct roar_stream * s, int role) _LIBROAR_STREAM_STDATTRS;
Index: libroar/enumdev.c
===================================================================
--- libroar/enumdev.c	(revision 5145)
+++ libroar/enumdev.c	(revision 5238)
@@ -52,5 +52,5 @@
 
  roar_libroar_nowarn();
- if ( roar_connect2(&con, c->server, 0, 0) == -1 ) {
+ if ( roar_connect(&con, c->server, 0, 0) == -1 ) {
   roar_libroar_warn();
   return -1;
Index: libroar/simple.c
===================================================================
--- libroar/simple.c	(revision 5237)
+++ libroar/simple.c	(revision 5238)
@@ -82,5 +82,5 @@
  }
 
- if ( roar_stream_connect2(&con, s, dir, -1) == -1 ) {
+ if ( roar_stream_connect(&con, s, dir, -1) == -1 ) {
   safe_error = roar_error;
   roar_disconnect(&con);
@@ -254,5 +254,5 @@
  }
 
- if ( roar_stream_connect2(con, s, dir, -1) == -1 ) {
+ if ( roar_stream_connect(con, s, dir, -1) == -1 ) {
   return -1;
  }
@@ -417,8 +417,8 @@
   return -1;
 
- if ( roar_stream_connect2(con, s, dir, -1) == -1 )
-  return -1;
-
- if ( roar_stream_set_flags2(con, s, ROAR_FLAG_VIRTUAL, ROAR_SET_FLAG) == -1 ) {
+ if ( roar_stream_connect(con, s, dir, -1) == -1 )
+  return -1;
+
+ if ( roar_stream_set_flags(con, s, ROAR_FLAG_VIRTUAL, ROAR_SET_FLAG) == -1 ) {
   roar_kick(con, ROAR_OT_STREAM, roar_stream_get_id(s));
   return -1;
Index: libroar/stream.c
===================================================================
--- libroar/stream.c	(revision 5229)
+++ libroar/stream.c	(revision 5238)
@@ -36,9 +36,5 @@
 #include "libroar.h"
 
-int roar_stream_connect  (struct roar_connection * con, struct roar_stream * s, int dir) {
- return roar_stream_connect2(con, s, dir, -1);
-}
-
-int roar_stream_connect2 (struct roar_connection * con, struct roar_stream * s, int dir, int mixer) {
+int roar_stream_connect(struct roar_connection * con, struct roar_stream * s, int dir, int mixer) {
  struct roar_libroar_config * config = roar_libroar_get_config();
  struct roar_stream  ms;
@@ -380,61 +376,4 @@
 }
 
-int roar_stream_add_data (struct roar_connection * con, struct roar_stream * s, char * data, size_t len) {
- struct roar_message m;
-
- if ( con == NULL || s == NULL || data == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- memset(&m,  0, sizeof(m));
-
- m.cmd     = ROAR_CMD_ADD_DATA;
- m.stream  = s->id;
- m.pos     = 0;
- m.datalen = len;
-
-// if ( roar_req(con, &m, (void**)&data) == -1 )
-//  return -1;
- if ( roar_send_message(con, &m, data) != 0 )
-  return -1;
-
- if ( roar_recv_message(con, &m, NULL) == -1 )
-  return -1;
-
- if ( m.cmd == ROAR_CMD_OK )
-  return 0;
- return -1;
-}
-
-int roar_stream_send_data (struct roar_connection * con, struct roar_stream * s, char * data, size_t len) {
-
- roar_debug_warn_obsolete("roar_stream_send_data", "roar_vio_write", NULL);
-
- if ( s == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- if ( s->fh == -1 ) {
-  if ( con == NULL ) {
-   roar_err_set(ROAR_ERROR_NOTSUP);
-   return -1;
-  }
-
-  if ( roar_stream_add_data(con, s, data, len) == -1 )
-   return -1;
-
-  return len;
- }
-
-#ifdef ROAR_HAVE_IO_POSIX
- return ROAR_NETWORK_WRITE(s->fh, data, len);
-#endif
-
- roar_err_set(ROAR_ERROR_NOTSUP);
- return -1;
-}
-
 int roar_stream_get_info (struct roar_connection * con, struct roar_stream * s, struct roar_stream_info * info) {
  struct roar_message m;
@@ -709,9 +648,5 @@
 
 
-int roar_stream_set_flags (struct roar_connection * con, struct roar_stream * s, int flags, int reset) {
- return roar_stream_set_flags2(con, s, flags, reset == ROAR_RESET_FLAG ? ROAR_RESET_FLAG : ROAR_SET_FLAG);
-}
-
-int roar_stream_set_flags2 (struct roar_connection * con, struct roar_stream * s, uint32_t flags, int action) {
+int roar_stream_set_flags (struct roar_connection * con, struct roar_stream * s, uint32_t flags, int action) {
  struct roar_message m;
  uint16_t * data = (uint16_t *) m.data;
Index: libroar/vio_stream.c
===================================================================
--- libroar/vio_stream.c	(revision 5118)
+++ libroar/vio_stream.c	(revision 5238)
@@ -121,5 +121,5 @@
  }
 
- if ( roar_stream_connect2(con, &stream, dir, -1) == -1 ) {
+ if ( roar_stream_connect(con, &stream, dir, -1) == -1 ) {
   err = roar_error;
   roar_disconnect(con);
Index: libroar/vs.c
===================================================================
--- libroar/vs.c	(revision 5236)
+++ libroar/vs.c	(revision 5238)
@@ -1050,5 +1050,5 @@
   case ROAR_VS_TRUE:
   case ROAR_VS_FALSE:
-    if ( roar_stream_set_flags2(vss->con, &(vss->stream), flag,
+    if ( roar_stream_set_flags(vss->con, &(vss->stream), flag,
                                 val == ROAR_VS_TRUE ? ROAR_SET_FLAG : ROAR_RESET_FLAG) == -1 ) {
      _seterrre();
Index: libroarrsound/libroarrsound.c
===================================================================
--- libroarrsound/libroarrsound.c	(revision 4893)
+++ libroarrsound/libroarrsound.c	(revision 5238)
@@ -500,5 +500,5 @@
   return -1;
 
- return roar_stream_set_flags2(&(self->con), &(self->stream), ROAR_FLAG_PAUSE, enable ? ROAR_SET_FLAG : ROAR_RESET_FLAG);
+ return roar_stream_set_flags(&(self->con), &(self->stream), ROAR_FLAG_PAUSE, enable ? ROAR_SET_FLAG : ROAR_RESET_FLAG);
 }
 
Index: libroaryiff/playback.c
===================================================================
--- libroaryiff/playback.c	(revision 5221)
+++ libroaryiff/playback.c	(revision 5238)
@@ -100,5 +100,5 @@
  }
 
- if ( roar_stream_connect2(con, s, ROAR_DIR_PLAY, -1) == -1 ) {
+ if ( roar_stream_connect(con, s, ROAR_DIR_PLAY, -1) == -1 ) {
   close(in);
   return -1;
Index: plugins/gstreamer0.10/roarmixer.c
===================================================================
--- plugins/gstreamer0.10/roarmixer.c	(revision 5236)
+++ plugins/gstreamer0.10/roarmixer.c	(revision 5238)
@@ -363,7 +363,7 @@
 
   if (mute) {
-    _LIBROAR_IGNORE_RET(roar_stream_set_flags2(&(mixer->con), &s, ROAR_FLAG_MUTE, ROAR_SET_FLAG));
+    _LIBROAR_IGNORE_RET(roar_stream_set_flags(&(mixer->con), &s, ROAR_FLAG_MUTE, ROAR_SET_FLAG));
   } else {
-    _LIBROAR_IGNORE_RET(roar_stream_set_flags2(&(mixer->con), &s, ROAR_FLAG_MUTE, ROAR_RESET_FLAG));
+    _LIBROAR_IGNORE_RET(roar_stream_set_flags(&(mixer->con), &s, ROAR_FLAG_MUTE, ROAR_RESET_FLAG));
   }
 }
Index: roarclients/.release-helper
===================================================================
--- roarclients/.release-helper	(revision 5226)
+++ roarclients/.release-helper	(revision 5238)
@@ -2,3 +2,4 @@
 @RM roarcatsendfile.c
 @RM roarcat2sock.c
+@RM roarcatad.c
 #!END
Index: roarclients/Makefile
===================================================================
--- roarclients/Makefile	(revision 5226)
+++ roarclients/Makefile	(revision 5238)
@@ -9,5 +9,5 @@
 
 #TARGETS_TESTS=pinentrytest zcattest pgptest pipetest polytest roarfctest
-#TARGETS_OLD=roarcatad roarcatpassfh roarsocktypes
+#TARGETS_OLD=roarcatpassfh roarsocktypes
 
 TARGETS=$(TARGETS_IO) $(TARGETS_CTL) $(TARGETS_DSP) $(TARGETS_MISC) $(TARGETS_DEVEL) $(TARGETS_EXAMPLE) $(TARGETS_M) $(TARGETS_VIO)
Index: roarclients/roarcat.c
===================================================================
--- roarclients/roarcat.c	(revision 5202)
+++ roarclients/roarcat.c	(revision 5238)
@@ -187,5 +187,5 @@
  }
 
- if ( roar_stream_connect2(&con, &s, dir, -1) == -1 ) {
+ if ( roar_stream_connect(&con, &s, dir, -1) == -1 ) {
   fprintf(stderr, "Error: can not connect stream to server\n");
   roar_disconnect(&con);
Index: roarclients/roarcatad.c
===================================================================
--- roarclients/roarcatad.c	(revision 5109)
+++ roarclients/roarcatad.c	(revision 5238)
@@ -89,5 +89,5 @@
  }
 
- if ( roar_stream_connect2(&con, &s, ROAR_DIR_PLAY, -1) == -1 ) {
+ if ( roar_stream_connect(&con, &s, ROAR_DIR_PLAY, -1) == -1 ) {
   roar_disconnect(&con);
   return 1;
Index: roarclients/roarcatpassfh.c
===================================================================
--- roarclients/roarcatpassfh.c	(revision 5109)
+++ roarclients/roarcatpassfh.c	(revision 5238)
@@ -91,5 +91,5 @@
  }
 
- if ( roar_stream_connect2(&con, &s, ROAR_DIR_PLAY, -1) == -1 ) {
+ if ( roar_stream_connect(&con, &s, ROAR_DIR_PLAY, -1) == -1 ) {
   roar_disconnect(&con);
   return 1;
Index: roarclients/roarctl.c
===================================================================
--- roarclients/roarctl.c	(revision 5236)
+++ roarclients/roarctl.c	(revision 5238)
@@ -1059,5 +1059,5 @@
  }
 
- return roar_stream_set_flags2(con, s, f, action);
+ return roar_stream_set_flags(con, s, f, action);
 }
 
Index: roarclients/roarinterconnect.c
===================================================================
--- roarclients/roarinterconnect.c	(revision 5185)
+++ roarclients/roarinterconnect.c	(revision 5238)
@@ -505,5 +505,5 @@
  }
 
- if ( roar_stream_connect2(con, stream, localdir, -1) == -1 ) {
+ if ( roar_stream_connect(con, stream, localdir, -1) == -1 ) {
   roar_disconnect(con);
   return 22;
Index: roarclients/roarmon.c
===================================================================
--- roarclients/roarmon.c	(revision 5109)
+++ roarclients/roarmon.c	(revision 5238)
@@ -198,5 +198,5 @@
  }
 
- if ( roar_stream_connect2(&con, &s, dir, -1) == -1 ) {
+ if ( roar_stream_connect(&con, &s, dir, -1) == -1 ) {
   fprintf(stderr, "Error: can not connect stream to server\n");
   roar_disconnect(&con);
@@ -205,5 +205,5 @@
 
  if ( prethru ) {
-  if ( roar_stream_set_flags2(&con, &s, ROAR_FLAG_PRETHRU, ROAR_SET_FLAG) == -1 ) {
+  if ( roar_stream_set_flags(&con, &s, ROAR_FLAG_PRETHRU, ROAR_SET_FLAG) == -1 ) {
    fprintf(stderr, "Error: can not set prethru flag on stream\n");
    roar_disconnect(&con);
Index: roarclients/roarmonhttp.c
===================================================================
--- roarclients/roarmonhttp.c	(revision 5109)
+++ roarclients/roarmonhttp.c	(revision 5238)
@@ -331,5 +331,5 @@
  }
 
- if ( roar_stream_connect2(&con, &s, dir, -1) == -1 ) {
+ if ( roar_stream_connect(&con, &s, dir, -1) == -1 ) {
   roar_disconnect(&con);
   return 11;
@@ -337,5 +337,5 @@
 
  if ( sflags != ROAR_FLAG_NONE ) {
-  if ( roar_stream_set_flags2(&con, &s, sflags, ROAR_SET_FLAG) == -1 ) {
+  if ( roar_stream_set_flags(&con, &s, sflags, ROAR_SET_FLAG) == -1 ) {
    roar_disconnect(&con);
    return 14;
Index: roarclients/roarradio.c
===================================================================
--- roarclients/roarradio.c	(revision 5179)
+++ roarclients/roarradio.c	(revision 5238)
@@ -211,5 +211,5 @@
  }
 
- if ( roar_stream_connect2(con, stream, ROAR_DIR_PLAY, -1) == -1 ) {
+ if ( roar_stream_connect(con, stream, ROAR_DIR_PLAY, -1) == -1 ) {
   roar_disconnect(con);
   return 1;