Index: plugins/bash/roaraudio
===================================================================
--- plugins/bash/roaraudio	(revision 4145)
+++ plugins/bash/roaraudio	(revision 5124)
@@ -69,5 +69,5 @@
  x11sock=$(xprop -root 2>/dev/null | grep '^ROAR_SERVER(STRING) = ' | sed 's/^[^"]*"//; s/"$//')
 
- words="$link $nodes $stdsocks $x11sock +slp +fork"
+ words="$link $nodes $stdsocks $x11sock +slp +fork +abstract"
 
  compgen -A hostname $cur
@@ -107,5 +107,5 @@
     local cur
     cur="${COMP_WORDS[COMP_CWORD]}"
-    COMPREPLY=($(compgen -W "meta primary sync cleanmeta hwmixer pause mute mmap antiecho recsource passmixer virtual prethru immutable enhance" -- ${cur}))
+    COMPREPLY=($(compgen -W "meta primary sync cleanmeta hwmixer pause mute mmap antiecho recsource passmixer virtual prethru immutable enhance singlesink" -- ${cur}))
 }
 
@@ -119,5 +119,6 @@
     local cur
     cur="${COMP_WORDS[COMP_CWORD]}"
-    COMPREPLY=($(compgen -W "none title album author autor artist version date license tracknumber organization description genre location contact streamurl homepage thumbnail length comment other filename fileurl server duration www woaf encoder encodedby year discid rpg_track_peak rpg_track_gain rpg_album_peak rpg_album_gain hash signalinfo audioinfo offset performer copyright" -- ${cur}))
+#phi@ph7:roaraudio $ echo $(grep '^#define ROAR_META_TYPE_' include/roaraudio/meta.h  | cut -d_ -f4,5,6,7,8,9 | cut -d' ' -f1 | tr A-Z a-z)
+    COMPREPLY=($(compgen -W "none title album author autor artist version date license tracknumber organization description genre location contact streamurl homepage thumbnail length comment other filename fileurl server duration www woaf encoder encodedby year discid rpg_track_peak rpg_track_gain rpg_album_peak rpg_album_gain hash signalinfo audioinfo offset performer copyright likeness composer rights isrc language gtin isbn ean publisher discnumber sourcemedia label labelno" -- ${cur}))
 }
 
@@ -559,5 +560,5 @@
 {
     local cur prev opts
-    local opts_misc opts_audio opts_stream opts_driver opts_output opts_source opts_cf opts_midi opts_rdtcs opts_server opts_plugins
+    local opts_misc opts_auth opts_plugins opts_audio opts_stream opts_rolestack opts_output opts_source opts_cf opts_midi opts_light opts_rdtcs opts_x11 opts_server
     COMPREPLY=()
     cur="${COMP_WORDS[COMP_CWORD]}"
@@ -567,18 +568,21 @@
     #  The basic options we'll complete.
     #
-    opts_misc="--daemon --verbose --terminate --start --restart --stop --shutdown --realtime --chroot --setgid --setuid --sysclocksync --location --pidfile"
+    opts_misc="--daemon --verbose --terminate --start --restart --stop --shutdown --realtime --memlock --chroot --setgid --setuid --sysclocksync --location --description --pidfile --log-syslog --script-postdown"
+    opts_auth="--guest-acclev --trust-acclev --trust-root --no-trust-root --authfile-gen --authfile-load --authfile-type --authfile-acclev --new-authfile"
+    opts_plugins="--plugin-load"
     opts_audio="--rate --bits --chans -R -B -C --aiprofile"
     opts_stream="--stream-flags"
-    opts_driver="--driver --device -d -D --list-driver"
-    opts_output="--odriver --odevice -o -O -oO -oP -oN"
+    opts_rolestack="--list-rolestack --rolestack-push"
+    opts_output="--odriver --odevice -o -O -oO -oP -oN --list-driver"
     opts_source="--source -s -S -sO -sP -sN --list-sources"
+    opts_mixer="-m --mixer -mO -mN -mP --list-mixers"
     opts_cf="--list-cf"
     opts_midi="--midi-no-console --midi-console-enable --midi-console --ssynth-enable --ssynth-disable"
     opts_light="--light-channels"
     opts_rdtcs="--rds-pi --rds-ps --rds-pty --rds-tp --rds-ct"
-    opts_server="--tcp --unix --decnet -t -u -n -4 -6 -64 --port -p --bind -b --sock --proto --proto-dir --proto-rate --proto-bits --proto-codec --proto-chans --list-proto --list-profiles --proto-profile --proto-aiprofile --new-sock --slp --x11 --jumbo-mtu -G -U --no-listen --client-fh --close-fh --standby --auto-standby"
-    opts_plugins="--plugin-load"
-
-    opts="$opts_misc $opts_audio $opts_stream $opts_driver $opts_output $opts_source $opts_cf $opts_midi $opts_light $opts_rdtcs $opts_server $opts_plugins --help"
+    opts_x11="--x11-display --display"
+    opts_server="--tcp --unix --decnet -t -u -n -4 -6 -64 --port -p --bind -b --sock --proto --proto-dir --proto-rate --proto-bits --proto-codec --proto-chans --list-proto --list-profiles --proto-profile --proto-aiprofile --list-aiprofiles --new-sock --slp --x11 --jumbo-mtu -G -U --no-listen --client-fh --close-fh --standby --auto-standby"
+
+    opts="$opts_misc $opts_auth $opts_plugins $opts_audio $opts_stream $opts_rolestack $opts_output $opts_source $opts_mixer $opts_cf $opts_midi $opts_light $opts_rdtcs $opts_x11 $opts_server --help"
 
 
@@ -596,10 +600,32 @@
 	    return 0
             ;;
+	'--script-postdown')
+            _filedir
+	    return 0
+            ;;
         '--plugin-load')
             _filedir
 	    return 0
             ;;
+	'--authfile-gen'|'--authfile-load')
+            _filedir
+	    return 0
+            ;;
+# MemLock:
+	'--memlock')
+            COMPREPLY=($(compgen -W "none low medium high nearlyall nearlyallsys allcur all default" -- ${cur}))  
+	    return 0
+            ;;
+# Acclev
+	'--guest-acclev'|'--trust-acclev'|'--authfile-acclev')
+            COMPREPLY=($(compgen -W "none idented conctl guest user pwruser all" -- ${cur}))  
+	    return 0
+            ;;
+	'--authfile-type')
+            COMPREPLY=($(compgen -W "roar esd pulse htpasswd xauth" -- ${cur}))  
+	    return 0
+            ;;
 # String:
-	'--location')
+	'--location'|'--description')
 	    return 0
             ;;
@@ -629,10 +655,9 @@
 	    return 0
             ;;
+# R:A
+	'--rolestack-push')
+	    return 0
+            ;;
 # driver:
-	'--driver'|'-d')
-            words=$(roard --list-driver | tail -n +3 | sed 's/^ *//; s/ .*$//')
-            COMPREPLY=($(compgen -W "${words}" -- ${cur}))  
-	    return 0
-            ;;
 	'--odriver'|'-o')
             words=$(roard --list-driver | tail -n +3 | sed 's/^ *//; s/ .*$//')
@@ -648,8 +673,4 @@
 # Device:
 # FIXME: add support for non file devices
-	'--device'|'-D')
-            _filedir
-	    return 0
-            ;;
 	'--odevice'|'-O')
             _filedir
@@ -682,4 +703,8 @@
             ;;
 	'--rds-pty')
+	    return 0
+            ;;
+# X11:
+	'--x11-display'|'--display')
 	    return 0
             ;;