Index: doc/man1/roarctl.1
===================================================================
--- doc/man1/roarctl.1	(revision 4818)
+++ doc/man1/roarctl.1	(revision 5159)
@@ -21,6 +21,21 @@
 
 .TP
-\fB-v\fR
+\fB--verbose\fR, \fB\-v\fR
 Be verbose. May be used multiple times.
+
+.TP
+\fB--list-libstandards\fR
+Similar to serverstandards, reports the list of standard libroar supports.
+
+.TP
+\fB--list-aiprofiles\fR
+Show audio info profiles and exit.
+
+.TP
+\fB--enum-servers\fR
+List servers found on the network.
+Depending on the build options of libroar this includes results from many tests
+like standard server locations, OpenSLP located servers, X11 located servers,
+DECnet's neighbor and IP's ARP table and other sources.
 
 .SH "NETWORK OPTIONS"
@@ -35,6 +50,25 @@
 
 .TP
+\fBlistaiprofiles\fR
+List audio info profiles.
+
+.TP
+\fBaiprofileget PROFILE\fR
+Display a the given audio info profile.
+
+.TP
 \fBsleep TIME\fR
 Sleeps for TIME seconds.
+
+.TP
+\fBping NUM\fR
+Pings the server NUM times. This is done by sending NOOP commands to the server.
+The response time as well as as a small statistics section is printed.
+
+This is not supported on all platforms.
+
+.TP
+\fBwhoami\fR
+Report client ID of roarctl on the current server.
 
 .TP
@@ -84,11 +118,54 @@
 
 .TP
-\fBflag ID FLAGS\fR, \fBunflag ID FLAGS\fR
-Sets or removes flags from a stream. ID is the stream id.
+\fBnewvirtual P D E R B C\fR
+Adds a new virtual (child) stream.
+This is used with container formats such as RAUM, Ogg and Matroska.
+
+
+Parameters:
+.RS
+.TP
+\fBP\fR
+Stream ID of \fBP\fRarent stream.
+.TP
+\fBD\fR
+Stream \fBD\fRirection.
+.TP
+\fBE\fR
+Stream cod\fBE\fRc.
+.TP
+\fBR\fR
+Sample \fBR\fRate.
+.TP
+\fBB\fR
+\fBB\fRits per sample.
+.TP
+\fBC\fR
+Number of \fBC\fRhannels.
+.RE
+
+.TP
+\fBflag ID FLAGS\fR, \fBunflag ID FLAGS\fR, \fBtoogleflag ID FLAGS\fR
+Sets, removes or toggles flags on a stream. ID is the stream id.
 FLAGS is a comma separated list of flags.
 
 It is not possible to set all kinds of flags at runtime.
 
+.TP
+\fBprotectflag ID FLAGS\fR
+Protects flags on a stream. ID is the stream id.
+FLAGS is a comma separated list of flags.
+
+Protected flags can not be changed anymore after the they got protected.
+
 .SH "META DATA COMMANDS"
+.TP
+\fBrole ID ROLE\fR
+Set stream role ROLE on stream ID.
+
+.TP
+\fBmetaget ID TYPE\fR
+Read meta date of type TYPE from stream ID.
+
 .TP
 \fBmetasave ID FILE\fR
@@ -102,5 +179,23 @@
 as for \fBmetasave\fR.
 
-.SH "LISTING COMMANDS"
+.SH "SERVER INFO COMMANDS"
+.TP
+\fBserverinfo\fR
+Gets general information about the server.
+This includes software vendor and version.
+
+.TP
+\fBservertime\fR
+Reports the server's system time.
+
+.TP
+\fBserverstandards\fR
+Report a list of standards the server supports.
+
+.TP
+\fBlibstandards\fR
+Similar to serverstandards, reports the list of standard libroar supports.
+Same as \fB--list-libstandards\fR.
+
 .TP
 \fBserveroinfo\fR
@@ -111,4 +206,5 @@
 Gets Information about server output for a given direction.
 
+.SH "LISTING COMMANDS"
 .TP
 \fBlistclients\fR
Index: doc/man1/roard.1
===================================================================
--- doc/man1/roard.1	(revision 5146)
+++ doc/man1/roard.1	(revision 5159)
@@ -38,4 +38,47 @@
 Sets default memory locking level to LEVEL.
 
+Valid levels are:
+.RS
+.TP
+\fBnone\fR
+No memory is locked at all.
+
+.TP
+\fBlow\fR
+Only very few (important) objects are locked in memory.
+
+.TP
+\fBmedium\fR
+Few (important) objects are locked in memory.
+
+.TP
+\fBhigh\fR
+Many objects are locked in memory.
+
+.TP
+\fBnearlyall\fR
+All known objects are locked in memory.
+
+.TP
+\fBnearlyallsys\fR
+All known objects are locked in memory but also pages provided by the system like stack and heap.
+
+.TP
+\fBallcur\fR
+All currently used pages are locked in memory.
+
+.TP
+\fBall\fR
+All pages (including future allocated pages) are locked in memory.
+
+.TP
+\fBdefault\fR
+Use defaults (the default).
+
+.RE
+
+A higher memlock level may result in memory allocations problems at runtime and even segfauls on some systems.
+(VM killed processes). Check your current system limits before altering this value.
+
 .TP
 \fB--pidfile PIDFILE\fR
@@ -138,10 +181,50 @@
 
 .SH "AUTH OPTIONS"
-.TP
-\fB--guest-acclev\fR
+The following options control the access rights of connections.
+Some of them take an access level. The access level is one from the following list:
+.RS
+.TP
+\fBnone\fR
+This is used to disable an authentication method.
+
+.TP
+\fBidented\fR
+Used internally. Should not be used.
+
+.TP
+\fBconctl\fR
+The client is only allowed to do some basic operations only affecting it's own connection.
+
+.TP
+\fBguest\fR
+Guest access (read only). The client may list resources but not alter them.
+
+.TP
+\fBuser\fR
+Normal user. The client may create and alter most resources.
+
+.TP
+\fBpwruser\fR
+Power User. The client can create and alter all resources and do all operation but operations
+which would break the POSIX right system. The user is not allowed to control the server itself
+like terminating it or alter (system) resources with the rights of the user runnung roard.
+
+This is the access level a fully trusted user in a multi user setup should have.
+
+.TP
+\fBall\fR
+The client can do everything. This includes operations which may alter system resources (like files)
+with the rights of the user running roard.
+
+This accesslevel should be given to the user in case of a single user setup or root or some administrator
+in a multi user setup.
+.RE
+
+.TP
+\fB--guest-acclev ACCESSLEVEL\fR
 Sets the access level for guest connections. Set to "none" to disable guest access.
 
 .TP
-\fB--trust-acclev\fR
+\fB--trust-acclev ACCESSLEVEL\fR
 Sets the access level for clients authenticated by trust auth.
 Set to "none" to disable trust auth.